
; C near-callable as:
;void scale(int x,int y,int w,int h,int origw,int origh,int source,int dest)
;// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
;// Procedure Scale (x,y,w,h,origw,origh,source,dest:word); assembler;
;//  { This scales the picture to the size of w and h, and places the result
;//    at x , y. Origw and origh are the origional width and height of the
;//    bitmap. The bitmap must start at the beginning of a segment, with
;//    source being the segment value. The image is placed in screen at dest}
;void scale(int x,int y,int w,int h,int origw,int origh,int source,int dest)
;{int jx,jy,depth,temp};

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	.286C
	IDEAL
	MODEL	SMALL, C
	JUMPS

;	INCLUDE '*.EQU'



;============================================================================

DATASEG
		jx      dw    ?
		jy      dw    ?
		depth   dw    ?
		temp    dw    ?


;============================================================================

CODESEG


	PROC _scale
	PUBLIC  _scale

;		jx      dw    ?
;		jy      dw    ?
;		depth   dw    ?
;		temp    dw    ?

		source  dw    ?
		dest    dw    ?
		h       dw    ?
		origw   dw    ?
		w       dw    ?
		origh   dw    ?
		y       dw    ?
		x       dw    ?

  push  ds
  mov   ax,[source]
  mov   ds,ax
  mov   ax,[dest]
  mov   es,ax
  mov   [depth],0
  dec   [h]
  xor   dx,dx
  mov   ax,[origw]
  shl   ax,6
  mov   bx,[w]
  div   bx
  shl   ax,2
  mov   [jx],ax    ; { jx:=origw*256/w }
  xor   dx,dx
  mov   ax,[origh]
  shl   ax,6
  mov   bx,[h]
  div   bx
  shl   ax,2
  mov   [jy],ax    ; { jy:=origh*256/h }
  xor   cx,cx
ALoop2:          ; { vertical loop }
  push  cx
  mov   ax,[depth]
  add   ax,[jy]
  mov   [depth],ax
  xor   dx,dx
  mov   ax,[depth]
  shr   ax,8
  mov   bx,[origw]
  mul   bx
  mov   [temp],ax  ; { temp:=depth shr 8*origw;}
  mov   di,[y]
  add   di,cx
  mov   bx,di
  shl   di,8
  shl   bx,6
  add   di,bx
  add   di,[x]     ; { es:di = dest ... di=(loop1+y)*320+x }
  mov   cx,[w]
  xor   bx,bx
  mov   dx,[jx]
  mov   ax,[temp]
ALoop1:         ; { horizontal loop }
  mov   si,bx
  shr   si,8
  add   si,ax    ; { ax = temp = start of line }
  movsb          ; { si=temp+(si shr 8) }
  add   bx,dx
  dec   cx
  jnz   ALoop1   ; { horizontal loop }
  pop   cx
  inc   cx
  cmp   cx,[h]
  jl    ALoop2   ; { vertical loop }
  pop   ds
  ret

   endp _scale

   end


;  from Helpme!.tsm
;  Q. I am linking my own assembly language functions with Turbo C.
;     Why does the linker report that all of my functions are
;     undefined?
;  A. Make sure you've put an underbar character (_) in front
;     of all assembly language function names to be called
;     by Turbo C. If you use simplified segmentation and include
;     the C language specifier on the .MODEL directive, Turbo
;     Assembler will pre-append the underbar automatically for you.
;     Your assembly language program should be assembled with Case
;     Sensitivity (/ML or /MX). 
