

#include "tchead.h"


void Cls(unsigned char Col, unsigned char *Where);     //andadd

// declare a pointer to the offset of the VGA memory
unsigned char *vga = (unsigned char *) MK_FP(0xA000, 0);   //andadd
unsigned char *vaddr = NULL;        //andadd
unsigned char *vaddr1 = NULL;       //andadd

//void Flip2(unsigned char* Source, unsigned char* Dest);    //andadd

void Flip();         //andadd
void Flip1();         //andadd

char source[256][3];
char dest[256][3];
int dir;

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure LoadCELPal (FileName : String; Var Palette : Pallette);
//   { This loads in the pallette of the .CEL file into the variable Palette }
void loadcelpal(char* FileName, char Palette[][3] )
{
  FILE* fptr;

  if((fptr=fopen(FileName,"rb"))==NULL)
  {
    printf("Error opening file %s\n",FileName); 
	exit(1);
  }
  fseek(fptr,(long)32,SEEK_SET);
//  fread(Palette,1,768,fptr);
  fread(Palette,sizeof(char),768,fptr);
  fclose(fptr);
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure Init;
void Init()
{
  _fmemset(source,0,768);
  _fmemset(dest,0,768);
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure SetItUp;
//   { We define our third screen here }
void SetItUp()
{
    int loop1,loop2,loop3;
	char Pal1[256][3];
	char Pal2[256][3];
	int change;
	char r,g,b,r1,g1,b1;
//	int where;
//	unsigned char* where;

//       Cls (0,Vaddr1);

    for(loop1=0;loop1<256;loop1++) Pal ((char)loop1,0,0,0);

  LoadCEL ("from.cel",Virtual2);
  loadcelpal ("from.cel",Pal2);
  Flip1();
//  getch();    //andadd
//  loadcelpal ("from.cel",Pal1);
  LoadCEL ("to.cel",Virtual);
  loadcelpal ("to.cel",Pal1);
  Flip();
//  getch(); //andadd
//  where=0;
/*
  for(loop1=0;loop1<320;loop1++)
    for(loop2=0;loop2<200;loop2++)
    {
      if((GetPixel(loop1,loop2,Vaddr)!=0) || (GetPixel (loop1,loop2,VGA)!=0))
      {
	change=FALSE;
	r=Pal1[GetPixel(loop1,loop2,Vaddr)][0];
	g=Pal1[GetPixel(loop1,loop2,Vaddr)][1];
	b=Pal1[GetPixel(loop1,loop2,Vaddr)][2];
	r1=Pal2[GetPixel(loop1,loop2,VGA)][0];
        g1=Pal2[GetPixel(loop1,loop2,VGA)][1];
        b1=Pal2[GetPixel(loop1,loop2,VGA)][2];
            
	for(loop3=0;loop3<=where;loop3++)
          if ((source[loop3][0]==r) && (source[loop3][1]==g) && (source[loop3][2]==b) &&
             (dest[loop3][0]==r1) && (dest[loop3][1]==g1) && (dest[loop3][2]==b1))
          {    
	     PutPixel (loop1,loop2,(char)loop3,Vaddr1);
             change=TRUE;
          }
        //  { Here we check that this combination hasn't occured before. If it
	//    has, put the appropriate pixel onto the third screen (vaddr1) }

        if (!(change) )
        {
	  where++;
	  if (where==256)
          {
            SetText();
            printf("Pictures have too many colors! Squeeze then retry!\n");
            exit(1);
            // { There were too many combinations of colors. Alter picture and
            //  then retry }
			// E.g. 16 colors per picture would be a max of 256 combinations, so
			// should work every time.
          }
	  PutPixel(loop1,loop2,(char)where,Vaddr1);
	  source[where][0]=Pal1[GetPixel(loop1,loop2,Vaddr)][0];
	  source[where][1]=Pal1[GetPixel(loop1,loop2,Vaddr)][1];
	  source[where][2]=Pal1[GetPixel(loop1,loop2,Vaddr)][2];
	  dest[where][0]=Pal2[GetPixel(loop1,loop2,VGA)][0];
	  dest[where][1]=Pal2[GetPixel(loop1,loop2,VGA)][1];
          dest[where][2]=Pal2[GetPixel(loop1,loop2,VGA)][2];
          //  { Create a new color and set it's from and to pallette values }
        }
      }
    }         */
//  Cls (0,VGA);
//  Flip1(Vaddr1,VGA);
//  Flip1();
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure Crossfade (direction:boolean;del,farin:word);
// { This fades from one picture to the other in the direction specified
//     with a del delay. It crossfades one degree for every value in farin.
//    If farin=63, then a complete crossfade occurs }
void Crossfade(int direction, int del, int farin)
{
  int loop1,loop2;
  char temp[256][3];
  char far* tempptr=&temp[0][0];
    
  if (direction)
  {
    _fmemcpy(temp,source,768);
    for(loop1=0;loop1<256;loop1++)
      Pal ((char)loop1,source[loop1][0],source[loop1][1],source[loop1][2]);
    for(loop1=0;loop1<=farin;loop1++)
    {
      WaitRetrace();
      SetAllPal(tempptr);

      for(loop2=0;loop2<256;loop2++)
      {
        if( temp[loop2][0]<dest[loop2][0])temp[loop2][0]++;
        if( temp[loop2][0]>dest[loop2][0])temp[loop2][0]--;
        if( temp[loop2][1]<dest[loop2][1])temp[loop2][1]++;
        if( temp[loop2][1]>dest[loop2][1])temp[loop2][1]--;
        if( temp[loop2][2]<dest[loop2][2])temp[loop2][2]++;
        if( temp[loop2][2]>dest[loop2][2])temp[loop2][2]--;                 
        //  { Move temp (the current pallette) from source to dest }
      }
      delay (del);
    }
  }
  else 
  {
    _fmemcpy(temp,dest,768);
    for(loop1=0;loop1<256;loop1++)
      Pal ((char)loop1,dest[loop1][0],dest[loop1][1],dest[loop1][2]);
    for(loop1=0;loop1<=farin;loop1++)
    {
      WaitRetrace();
      SetAllPal(tempptr);

      for(loop2=0;loop2<256;loop2++)
      {
        if( temp[loop2][0]<source[loop2][0])temp[loop2][0]++;
        if( temp[loop2][0]>source[loop2][0])temp[loop2][0]--;
        if( temp[loop2][1]<source[loop2][1])temp[loop2][1]++;
        if( temp[loop2][1]>source[loop2][1])temp[loop2][1]--;
        if( temp[loop2][2]<source[loop2][2])temp[loop2][2]++;
        if( temp[loop2][2]>source[loop2][2])temp[loop2][2]--;                 
        //  { Move temp (the current pallette) from source to dest }
      }
      delay (del);
    }
  }
}

// Cls() - This clears the screen to the specified color, on the VGA or on //
//         the Virtual screen.                                             //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void Cls(unsigned char Col, unsigned char *Where) {    //andadd
//  _fmemset(Where, Col, 64000);
  _fmemset(Where, Col, 64800);    //andadd
}


// procedure flip(source,dest:Word);
//   { This copies the entire screen at "source" to destination }

/*
void Flip2(unsigned char* Source, unsigned char* Dest)
{
  asm {
    push    ds
    mov     ax, Dest
    mov     es, ax
    mov     ax, Source
    mov     ds, ax
    xor     si, si
    xor     di, di
    mov     cx, 32000
    rep     movsw
    pop     ds
  }
}
*/

// Flip() - This flips the virtual screen to the VGA screen.               //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void Flip() {                          //andadd
//  _fmemcpy(vga,vaddr,64000);
  _fmemcpy(vga,vaddr,64800);     //andadd
}

// Flip1() - This flips the virtual screen to the VGA screen.               //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void Flip1() {                          //andadd
//  _fmemcpy(vga,vaddr1,64000);
  _fmemcpy(vga,vaddr1,64800);     //andadd
}



void main()
{
  int loop1;
//  _clearscreen(_GCLEARSCREEN);
  clrscr();
  SetUpVirtual();
  SetMCGA();
  Init();
  SetItUp();
  for(loop1=0;loop1<256;loop1++)
    Pal((char)loop1,source[loop1][0],source[loop1][1],source[loop1][2]);
  Flip();
//  getch();
  Flip1();
//  getch();

//  delay (3000);
//  delay (300);

  dir=TRUE;
  while(!kbhit()) {
//  {
//    Crossfade(dir,20,63);
    Crossfade(dir,10,63);
    dir=1-dir; // Toggle
//    delay (1000);
//    if(_bios_keybrd(_KEYBRD_READY))break;
//  }
//  getch();
  Crossfade(dir,10,63);
//  getch();
  }
  SetText();
}


/*
BEGIN
  clrscr;
  writeln ('Hello there! This trainer program is on cross fading. What will happen');
  writeln ('is this : The program will load in two .CEL files, FROM.CEL and TO.CEL');
  writeln ('into the virtual screen at vaddr and to the VGA screen. The pallettes');
  writeln ('of these two pictures are loaded into pal1 and pal2. Note that you');
  writeln ('could easily rewrite this to load in other types of files if you do');
  writeln ('not own Autodesk Animator to draw your files (The pictures presented');
  writeln ('here were drawn by Fubar, sqeezed by me ;)). A third screen is then');
  Writeln ('generated into vaddr2 (this takes 5-10 seconds on my 386-40). Note');
  writeln ('that you could dump vaddr2 to disk as a file instead of calculating it');
  writeln ('each time...it would be faster and be half the size of the two pictures.');
  Writeln ('The picture will then crossfade between the two. Hit a key and it will');
  writeln ('crossfade halfway and then exit.');
  writeln;
  writeln ('After one particular comment E-Mailed to me, I thought I should just add');
  writeln ('this : I am not an employee of Autodesk, and they do not pay me to promote');
  writeln ('their product. You have no idea how much I wish they would :)  I recieve');
  writeln ('absolutely _nothing_ for writing the trainer...');
  writeln;
  writeln;
  write ('Hit any key to continue ...');
  readkey;
  randomize;
  setupvirtual;
  setmcga;
  init;
  SetItUp;
  for loop1:=0 to 255 do
    pal (loop1,source[loop1,1],source[loop1,2],source[loop1,3]);
  flip (vaddr2,vga);
  delay (3000);

  dir:=TRUE;
  while keypressed do readkey;
  repeat
    crossfade(dir,20,63);
    dir:=not (dir);
    delay (1000);
  until keypressed;
  Readkey;
  crossfade(dir,20,20);
  readkey;
  settext;
  Writeln ('All done. This concludes the eleventh sample program in the ASPHYXIA');
  Writeln ('Training series. You may reach DENTHOR under the names of GRANT');
  Writeln ('SMITH/DENTHOR/ASPHYXIA on the ASPHYXIA BBS. I am also an avid');
  Writeln ('Connectix BBS user, and occasionally read RSAProg. E-mail me at :');
  Writeln ('    smith9@batis.bis.und.ac.za');
  Writeln ('The numbers are available in the main text. You may also write to me at:');
  Writeln ('             Grant Smith');
  Writeln ('             P.O. Box 270');
  Writeln ('             Kloof');
  Writeln ('             3640');
  Writeln ('             Natal');
  Writeln ('             South Africa');
  Writeln ('I hope to hear from you soon!');
  Writeln; Writeln;
  Write   ('Hit any key to exit ...');
  readkey;
  shutdown;
  FreeMem (VirScr2,64000);
END.
*/
